
//
//  ViewController.m
//  SCRecorderWatermarkTest
//
//  Created by Jeremy Nelson on 5/11/16.
//  Copyright © 2016 Testing. All rights reserved.
//

#import "ViewController.h"
#import "SCRecorder.h"


@interface ViewController ()

@property (strong, nonatomic) NSURL *bundleUrl;
@property (weak, nonatomic) IBOutlet SCVideoPlayerView *playerView;

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    
    self.bundleUrl = [[NSBundle mainBundle] URLForResource:@"test" withExtension:@"MOV"];

    //UNCOMMENT this to see the original video (and comment out the call to tryWatermarking)
    //AVURLAsset *asset = [AVURLAsset assetWithURL:self.bundleUrl];
    //[self.playerView.player setItemByAsset:asset];
    //self.playerView.player.loopEnabled = YES;
    //[self.playerView.player play];
    
    //UNCOMMENT to prove that watermark is a valid image
    //UIImageView *imgView = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"watermark"]];
    //[self.view addSubview:imgView];
    
    [self tryWatermarking];
}

- (void)tryWatermarking {
    AVURLAsset *asset = [AVURLAsset assetWithURL:self.bundleUrl];
    NSURL *tempUrl = [NSURL fileURLWithPath:[NSTemporaryDirectory() stringByAppendingPathComponent:@"videowatermarked.mov"]];
    
    SCAssetExportSession *assetExportSession = [[SCAssetExportSession alloc] initWithAsset:asset];
    assetExportSession.outputUrl = tempUrl;
    assetExportSession.outputFileType = AVFileTypeMPEG4;
    assetExportSession.videoConfiguration.preset = SCPresetMediumQuality;
    assetExportSession.videoConfiguration.watermarkImage = [UIImage imageNamed:@"watermark"]; //watermark is in Assets.xcassets
    assetExportSession.videoConfiguration.watermarkFrame = CGRectMake(0, 0, 320, 480);
    [assetExportSession exportAsynchronouslyWithCompletionHandler: ^{
        if (assetExportSession.error == nil) {
            
            //NOTE - Watermark does not appear on the exported video
            [self.playerView.player setItemByUrl:assetExportSession.outputUrl];
            self.playerView.player.loopEnabled = YES;
            [self.playerView.player play];
            return;
            
            
        } else {
            // Something bad happened
            
        }
    }];

}


@end
